## com.bbn.openmap.omGraphics
Class OMPoint

    java.lang.Object
      com.bbn.openmap.omGraphics.geom.BasicGeometry
          com.bbn.openmap.omGraphics.OMGraphic
              com.bbn.openmap.omGraphics.OMPoint

All Implemented Interfaces:
  java.lang.Cloneable, OMGeometry, OMGraphicConstants, java.io.Serializable

Direct Known Subclasses:
  EsriPoint, GLPoint, GrabPoint, MIFPoint, Node, OMPoint.Image, RoadFinder.RedPoint, RoadFinder.YellowPoint

public class OMPoint
extends OMGraphic
implements java.io.Serializable

A OMPoint is used to mark a specific point. You can set this point as a lat/lon position, a screen X/Y position, or a lat/lon position with a screen X/Y offset. The position can be marked with a rectangle or circle with an adjusted radius. The radius is the pixel distance from the center of the location to each edge of the marking rectangle or circle.

See Also:
  Serialized Form

Nested Class Summary
`static class` `OMPoint.Image`

Field Summary
`static boolean` `DEFAULT_ISOVAL`
`static int` `DEFAULT_RADIUS`
`protected float` `lat1` Latitude of point, decimal degrees.
`protected float` `lon1` Longitude of point, decimal degrees.
`protected boolean` `oval` Set to true if you want little circles marking the point.
`protected int` `radius` The number of pixels in the radius for the point representation.
`protected int` `x` Horizontal window position of point, in pixels from left side of window.
`protected int` `y` Vertical window position of point, in pixels from the top of the window.

Fields inherited from class com.bbn.openmap.omGraphics.OMGraphic
`declutterType, displayPaint, edgeMatchesFill, fillPaint, hasLabel, linePaint, matted, mattingPaint, renderType, selected, selectPaint, showEditablePalette, stroke, textureMask`

Fields inherited from class com.bbn.openmap.omGraphics.geom.BasicGeometry
`APP_OBJECT_KEY, appObject, ATT_MAP_KEY, lineType, needToRegenerate, shape, visible`

Fields inherited from interface com.bbn.openmap.omGraphics.OMGraphicConstants

`ADD_GRAPHIC_MASK, BASIC_STROKE, CHANGE_APPEARANCE, clear, DECIMAL_DEGREES, DECLUTTERTYPE_LINE, DECLUTTERTYPE_MOVE, DECLUTTERTYPE_NONE, DECLUTTERTYPE_SPACE, DEFAULT_ROTATIONANGLE, DELETE_GRAPHIC_MASK, DESELECT_GRAPHIC_MASK, DESELECTALL_GRAPHIC_MASK, GRAPHICTYPE_ARC, GRAPHICTYPE_BITMAP, GRAPHICTYPE_CIRCLE, GRAPHICTYPE_ELLIPSE, GRAPHICTYPE_GRAPHIC, GRAPHICTYPE_GRID, GRAPHICTYPE_LINE, GRAPHICTYPE_POINT, GRAPHICTYPE_POLY, GRAPHICTYPE_RASTER, GRAPHICTYPE_RECTANGLE, GRAPHICTYPE_TEXT, INFOLINE, LABEL, LINETYPE_GREATCIRCLE, LINETYPE_RHUMB, LINETYPE_STRAIGHT, LINETYPE_UNKNOWN, LOWER_GRAPHIC_MASK, LOWER_TO_BOTTOM_GRAPHIC_MASK, RADIANS, RAISE_GRAPHIC_MASK, RAISE_TO_TOP_GRAPHIC_MASK, REMOVABLE, RENDERTYPE_LATLON, RENDERTYPE_OFFSET, RENDERTYPE_UNKNOWN, RENDERTYPE_XY, SELECT_GRAPHIC_MASK, SORT_GRAPHICS_MASK, TOOLTIP, UPDATE_GRAPHIC_MASK`

Constructor Summary
`OMPoint()` Default constructor, waiting to be filled.
`OMPoint(float lat, float lon)` Create an OMPoint at a lat/lon position, with the default radius.
`OMPoint(float lat, float lon, int radius)` Create an OMPoint at a lat/lon position, with the specified radius.
`OMPoint(float lat, float lon, int offsetx, int offsety)` Create an OMPoint at a lat/lon position with a screen X/Y pixel offset, with the default radius.
`OMPoint(float lat, float lon, int offsetx, int offsety, int radius)` Create an OMPoint at a lat/lon position with a screen X/Y pixel offset, with the specified radius.
`OMPoint(int x, int y)` Put the point at a screen location, marked with a rectangle with edge size DEFAULT_RADIUS * 2 + 1.
`OMPoint(int x, int y, int radius)` Put the point at a screen location, marked with a rectangle with edge size radius * 2 + 1.

Method Summary
`boolean` `generate(Projection proj)` Prepare the rectangle for rendering.
`float` `getLat()` Get the latitude of the point, in decimal degrees.
`float` `getLon()` Get the longitude of the point, in decimal degrees.
`int` `getRadius()` Get the radius for the point.
`int` `getX()` For screen x/y rendertype points.
`int` `getY()` For screen x/y rendertype points.
`protected boolean` `hasLineTypeChoice()` Used by the GraphicAttributes object to provide a choice on whether the line type choice can be changed.
`boolean` `isOval()` Get whether little circles should be marking the point.
`void` `set(float lat, float lon)` For lat/lon rendertype points, to move the point location.
`void` `set(float lat, float lon, int offsetx, int offsety)` For offset rendertype points, to move the point location.
`void` `set(int x, int y)` For screen x/y rendertype points, to move the point location.
`void` `setLat(float lat)` Set the latitude of the point, in decimal degrees.
`void` `setLon(float lon)` Set the longitude of the point, in decimal degrees.
`void` `setOval(boolean set)` Set whether little circles should be marking the point.
`void` `setRadius(int radius)` Set the radius of the marking rectangle.
`void` `setX(int x)` For screen x/y rendertype points.
`void` `setY(int y)` For screen x/y rendertype points.

Methods inherited from class com.bbn.openmap.omGraphics.OMGraphic

`clone, deselect, distance, getDeclutterType, getDescription, getDescription, getDisplayColor, getDisplayPaint, getEdgeMatchesFill, getFillColor, getFillPaint, getHasLabel, getLineColor, getLinePaint, getMattingPaint, getRenderType, getSelectColor, getSelectPaint, getShowEditablePalette, getStroke, getTextureMask, initLabelingDuringGenerate, isClear, isMatted, isSelected, normalizeDistanceForLineWidth, regenerate, render, renderLabel, select, setDeclutterType, setEdgeMatchesFill, setFillColor, setFillPaint, setGraphicsColor, setGraphicsForEdge, setGraphicsForFill, setHasLabel, setLabelLocation, setLabelLocation, setLabelLocation, setLineColor, setLinePaint, setMatted, setMattingPaint, setRenderType, setSelectColor, setSelected, setSelectPaint, setShape, setShowEditablePalette, setStroke, setTextureMask, shouldRenderEdge, shouldRenderFill`

Methods inherited from class com.bbn.openmap.omGraphics.geom.BasicGeometry

`_distance, appendShapeEdge, appendShapeEdge, appendShapeEdge, appendShapeEdge, checkAttributeMap, checkAttributeMap, clearAttributes, contains, createAttributeMap, createBoxShape, createShape, createShape, describeShapeDetail, describeShapeDetail, distanceToEdge, draw, fill, getAppObject, getAppObject, getAttribute, getAttributeMap, getAttributes, getLineType, getNeedToRegenerate, getShape, isRenderable, isVisible, putAttribute, removeAttribute, replaceAppObjectWithAttributeMap, setAppObject, setAppObject, setAttributes, setLineType, setNeedToRegenerate, setVisible`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.bbn.openmap.omGraphics.OMGeometry
`clearAttributes, contains, draw, fill, getAppObject, getAttribute, getAttributes, getLineType, getNeedToRegenerate, getShape, isRenderable, isVisible, putAttribute, removeAttribute, setAppObject, setAttributes, setLineType, setNeedToRegenerate, setVisible`

Field Detail

### DEFAULT_RADIUS

    public static final int DEFAULT_RADIUS

See Also:
  Constant Field Values

### DEFAULT_ISOVAL

    public static final boolean DEFAULT_ISOVAL

See Also:
  Constant Field Values

### radius

    protected int radius

  The number of pixels in the radius for the point representation.

### x

    protected int x

  Horizontal window position of point, in pixels from left side of window.

### y

    protected int y

  Vertical window position of point, in pixels from the top of the window.

### lat1

    protected float lat1

  Latitude of point, decimal degrees.

### lon1

    protected float lon1

  Longitude of point, decimal degrees.

### oval

    protected boolean oval

  Set to true if you want little circles marking the point.

Constructor Detail

### OMPoint

    public OMPoint()

  Default constructor, waiting to be filled.

### OMPoint

    public OMPoint(float lat,
                   float lon)

  Create an OMPoint at a lat/lon position, with the default radius.

### OMPoint

    public OMPoint(float lat,
                   float lon,
                   int radius)

  Create an OMPoint at a lat/lon position, with the specified radius.

### OMPoint

    public OMPoint(float lat,
                   float lon,
                   int offsetx,
                   int offsety)

  Create an OMPoint at a lat/lon position with a screen X/Y pixel offset, with the default radius.

### OMPoint

    public OMPoint(float lat,
                   float lon,
                   int offsetx,
                   int offsety,
                   int radius)

  Create an OMPoint at a lat/lon position with a screen X/Y pixel offset, with the specified radius.

### OMPoint

    public OMPoint(int x,
                   int y)

  Put the point at a screen location, marked with a rectangle with edge size DEFAULT_RADIUS * 2 + 1.

### OMPoint

    public OMPoint(int x,
                   int y,
                   int radius)

  Put the point at a screen location, marked with a rectangle with edge size radius * 2 + 1.

Method Detail

### set

    public void set(float lat,
                    float lon)

  For lat/lon rendertype points, to move the point location.

### set

    public void set(float lat,
                    float lon,
                    int offsetx,
                    int offsety)

  For offset rendertype points, to move the point location.

### set

    public void set(int x,
                    int y)

  For screen x/y rendertype points, to move the point location. This method does not call setX() and setY().

### setLat

    public void setLat(float lat)

  Set the latitude of the point, in decimal degrees.

### getLat

    public float getLat()

  Get the latitude of the point, in decimal degrees.

### setLon

    public void setLon(float lon)

  Set the longitude of the point, in decimal degrees.

### getLon

    public float getLon()

  Get the longitude of the point, in decimal degrees.

### setX

    public void setX(int x)

  For screen x/y rendertype points.

### getX

    public int getX()

  For screen x/y rendertype points.

### setY

    public void setY(int y)

  For screen x/y rendertype points.

### getY

    public int getY()

  For screen x/y rendertype points.

### setRadius

    public void setRadius(int radius)

  Set the radius of the marking rectangle. The edge size of the marking rectangle will be radius * 2 + 1.

### getRadius

    public int getRadius()

  Get the radius for the point.

### setOval

    public void setOval(boolean set)

  Set whether little circles should be marking the point.

  Parameters:
    `set` - true for circles.

### isOval

    public boolean isOval()

  Get whether little circles should be marking the point.

### generate

    public boolean generate(Projection proj)

  Prepare the rectangle for rendering.

  Specified by:
    `generate` in interface `OMGeometry`
  Specified by:
    `generate` in class `OMGraphic`
  Parameters:
    `proj` - Projection
  Returns:
    true if generate was successful
  See Also:
    `OMGraphic.regenerate(com.bbn.openmap.proj.Projection)`

### hasLineTypeChoice

    protected boolean hasLineTypeChoice()

  Description copied from class: `OMGraphic`
  Used by the GraphicAttributes object to provide a choice on whether the line type choice can be changed.

  Overrides:
    `hasLineTypeChoice` in class `OMGraphic`

Copyright (C) BBNT Solutions LLC; See http://openmap.bbn.com/ for details